fix btrbk service
[distro-setup] / switch-mail-host
old mode 100755 (executable)
new mode 100644 (file)
index 9ebd2a7..cbb7e69
@@ -4,33 +4,36 @@ set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 usage() {
-    cat <<EOF
+  cat <<EOF
 Usage: ${0##*/} OLD_HOST NEW_HOST
 
 Adjust home network dns so NEW_HOST resolves locally if it is on the
 local network.  Turn off mail receiving on OLD_HOST, run btrbk to move
 mail to NEW_HOST, turn on mail receiving on NEW_HOST.
 
+-o         Only btrbk /o, instead of all filesystems.
 -w         Don't try to ssh to wrt. Should only be used in unusual network situation.
 -h|--help  Print help and exit.
 
 Note: Uses GNU getopt options parsing style
 EOF
-    exit $1
+  exit $1
 }
 
 ##### begin command line parsing ########
 
 update_wrt=true # default
-temp=$(getopt -l help wh "$@") || usage 1
+temp=$(getopt -l help owh "$@") || usage 1
+mp_args=
 eval set -- "$temp"
 while true; do
-    case $1 in
-        -w) update_wrt=false; shift ;;
-        -h|--help) usage ;;
-        --) shift; break ;;
-        *) echo "$0: Internal error! unexpected args: $*" ; exit 1 ;;
-    esac
+  case $1 in
+    -o) mp_args="-m /o"; shift ;;
+    -w) update_wrt=false; shift ;;
+    -h|--help) usage ;;
+    --) shift; break ;;
+    *) echo "$0: Internal error! unexpected args: $*" ; exit 1 ;;
+  esac
 done
 
 
@@ -41,33 +44,33 @@ new_host=$2
 source /a/bin/bash_unpublished/source-semi-priv
 
 if [[ $old_host != $MAIL_HOST ]]; then
-    read -p "warning: \$old_host != \$MAIL_HOST: $old_host != $MAIL_HOST, proceed? y/N "
-    if [[ $REPLY != [yY] ]]; then
-        exit 1
-    fi
+  read -p "warning: \$old_host != \$MAIL_HOST: $old_host != $MAIL_HOST, proceed? y/N "
+  if [[ $REPLY != [yY] ]]; then
+    exit 1
+  fi
 fi
 
 if [[ $new_host == "$HOSTNAME" ]]; then
-    localhost_new=true
-    new_shell=
+  localhost_new=true
+  new_shell=
 else
-    localhost_new=false
-    new_shell="ssh $new_host"
+  localhost_new=false
+  new_shell="ssh $new_host"
 fi
 
 old_shell="ssh $old_host"
 if [[ $old_host == "$HOSTNAME" ]]; then
-    old_shell=
+  old_shell=
 fi
 
 if [[ ! $new_host || ! $old_host ]]; then
-    echo "$0: bad args. see script"
-    exit 1
+  echo "$0: bad args. see script"
+  exit 1
 fi
 
 at_home=false
-if [[ $HOSTNAME == tp ]] || [[ $HOSTNAME == frodo ]] || timeout -s 9 5 ssh wrt.b8.nz :; then
-    at_home=true
+if timeout -s 9 5 ssh-keyscan -p 2220 -t rsa 10.0.0.1 2>/dev/null | grep -qFx '[10.0.0.1]:2220 ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQCH+/h1dGEfKEusBblndU2e6QT4wLCm5+yqr/sqh/0X9YfjR7BfWWm8nNmuP55cYc+Wuf5ljB1H1acXEcsl1y8e0j3agHfF0V74FE1N1zz5nn2Ep8NHnmqgEhza38ZxMPh+4p3X7zklEKU7+3SzybKBi8sg0wLzlS2LM0JaUN80zR2sK11Kye3dURUXPk78u5wodOkgcEYRwSYaDMJlUzWP+poRXIDJwFaMQnwmxbl/c84yOyaU0x/d6hFwoRscWecihX+vvBNeSyxR4xr2HDOyUWwJkctyAgt2p7w3tfkXOKcCRzTAjGVIMQLTvo0sG/yJbcyHoEFdFybCsgDvfyYn'; then
+  at_home=true
 fi
 echo "$0: at_home = $at_home"
 
@@ -88,23 +91,17 @@ source /a/bin/bash_unpublished/source-semi-priv
 # because our port forward is not robust enough, we can't use proxy command,
 # todo: setup vpn so this is all taken care of.
 if ! $update_wrt; then
-    wrt_shell=:
-elif $at_home; then
-    wrt_shell="ssh wrt.b8.nz"
+  wrt_shell=:
 else
-    if [[ $old_host == iank.vpn.office.fsf.org || $new_host == iank.vpn.office.fsf.org ]]; then
-        wrt_shell="ssh iank.vpn.office.fsf.org ssh wrt.b8.nz"
-    else
-        wrt_shell="ssh $HOME_DOMAIN ssh wrt.b8.nz"
-    fi
+  wrt_shell="ssh wrt.b8.nz"
 fi
 
 btrbk_test="systemctl is-active btrbk.service"
 while $new_shell $btrbk_test || $old_shell $btrbk_test; do
-    echo "$0: btrbk is running on new or old host. sleeping for 8 seconds"
-    sleep 6
-    echo "$0: testing for btrbk activity in 2 seconds"
-    sleep 2
+  echo "$0: btrbk is running on new or old host. sleeping for 8 seconds"
+  sleep 6
+  echo "$0: testing for btrbk activity in 2 seconds"
+  sleep 2
 done
 
 new_hostname=$($new_shell hostname)
@@ -113,13 +110,13 @@ new_hostname=$($new_shell hostname)
 
 restore_new_btrbk=false
 if $new_shell systemctl is-active btrbk.timer; then
-    $new_shell sudo systemctl stop btrbk.timer
-    restore_new_btrbk=true
+  $new_shell sudo systemctl stop btrbk.timer
+  restore_new_btrbk=true
 fi
 restore_old_btrbk=false
 if $old_shell systemctl is-active btrbk.timer; then
-    $old_shell sudo systemctl stop btrbk.timer
-    restore_old_btrbk=true
+  $old_shell sudo systemctl stop btrbk.timer
+  restore_old_btrbk=true
 fi
 
 
@@ -129,81 +126,33 @@ if mountpoint -q /m; then sudo umount /m; fi
 if mountpoint -q /o; then sudo umount /o; fi
 EOF
 
-# if new_host is not on home network, make mail.iankelling.org not resolve
-# on the home network.
-if [[ $new_host == $HOSTNAME ]] && ! $at_home; then
-    echo | $wrt_shell cedit mail_host /etc/hosts || [[ $? == 1 ]] # 1 means file changed.
-else
-    $wrt_shell bash -xs $new_host <<'EOFOUTER'
-new_host=$1
-cedit mail_host /etc/hosts <<EOF || /etc/init.d/dnsmasq restart
-$(grep "\b$new_hostname\b" /etc/hosts | awk '{print $1}') mail.iankelling.org
-EOF
-EOFOUTER
-fi
+# previously, I was checking to see if the new mail host
+# is on my home network, then changing my home dns
+# to resolve on the local network, so that I didnt
+# have to send traffic out to the internet or rely
+# on that. However, that breaks for a laptop that roams.
+# So, we could have a cronjob that updates that dns,
+# however, another solution is to just use ipv6,
+# and I prefer that.
+#
+# TODO: enable ipv6 for email. exim config setting disables it.
+# need to add vpn support. need to add firewall / routing.
+# I think exim will try ipv6 first, so no need to disable
+# ipv6 i think.
 
-$old_shell /a/bin/distro-setup/install-my-scripts
 $old_shell primary-setup $new_hostname
 
-sudo dd of=/etc/btrbk.conf <<'EOF'
-ssh_identity /root/.ssh/home
-# Just a guess that local7 is a good facility to pick.
-# It's a bit odd that the transaction log has to be logged to
-# a file or syslog, while other output is sent to std out.
-# The man does not mention a way for them to be together, but
-# I dunno if setting a log level like warn might also output
-# transaction info.
-transaction_syslog local7
-
-# so we only run one at a time
-lockfile                   /var/lock/btrbk.lock
-
-# default format of short does not accomidate hourly preservation setting
-timestamp_format long-iso
-
-# only make a snapshot if things have changed
-snapshot_create onchange
-# I could make this different from target_preserve,
-# if one disk had less space.
-# for now, keeping them equal.
-snapshot_preserve 36h 14d 8w 24m
-snapshot_preserve_min 4h
-snapshot_dir btrbk
-
-# so, total backups = ~89
-target_preserve 36h 14d 8w 24m
-target_preserve_min 4h
-
-# if something fails and it's not obvious, try doing
-# btrbk -l debug -v dryrun
-
-
-EOF
-
-
 if $localhost_new; then
-    btrbk_src=ssh://$old_host/mnt/root
-    btrbk_dst=/mnt/root/btrbk
+  btrbk-run -s $old_host $mp_args
 else
-    btrbk_src=/mnt/root
-    btrbk_dst=ssh://$new_host/mnt/root/btrbk
+  btrbk-run -t $new_host $mp_args
 fi
 
-sudo tee -a /etc/btrbk.conf <<EOF
-volume $btrbk_src
-subvolume o
-target send-receive $btrbk_dst
-EOF
-
-
-sudo btrbk -l debug --progress run
-$new_shell /a/bin/distro-setup/install-my-scripts
-$new_shell mount-latest-subvol
 $new_shell primary-setup $new_hostname
 
 if $restore_new_btrbk; then
-    $new_shell sudo systemctl start btrbk.timer
+  $new_shell sudo systemctl start btrbk.timer
 fi
 if $restore_old_btrbk; then
-    $old_shell sudo systemctl start btrbk.timer
+  $old_shell sudo systemctl start btrbk.timer
 fi